SystemOrganization addCategory: #'Logo-Model'!
SystemOrganization addCategory: #'Logo-Seaside'!

PRStructure subclass: #LGLogoPage
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Logo-Model'!

!LGLogoPage class methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:55'!
asLabel
	^'Logo Page'! !

!LGLogoPage class methodsFor: 'accessing-description' stamp: 'pmm 6/5/2006 21:41'!
descriptionContents
	^ (MAMemoDescription selector: #code label: 'Code' priority: 200)
		default: String new;
		beEditable;
		yourself! !

!LGLogoPage class methodsFor: 'testing' stamp: 'pmm 6/5/2006 21:41'!
isAbstract
	^false! !

!LGLogoPage methodsFor: 'visiting' stamp: 'pmm 6/5/2006 21:56'!
accept: aVisitor
	aVisitor visitLogoPage: self! !

!LGLogoPage methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:40'!
code
	^code! !

!LGLogoPage methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:41'!
code: aString
	code := aString! !

!PRViewRenderer methodsFor: '*Logo' stamp: 'pmm 6/5/2006 22:16'!
visitLogoPage: anObject
	html addLoadScript: 'Logo.initialize()'.
	html div
		class: 'logo-root';
		with: [
			html div
				class: 'screenBox';
				with: [
					html canvas
						class: 'logo-screen';
						with: 200; height: 200 ].
			html div
				class: 'codeBox';
				with: [
					html textArea
						id: 'code1';
						class: 'logo-code';
						row: 15; columns: 30;
						on: #code of: anObject.
					html break.
					html imageButton
						class: 'logo-run';
						url: 'javascript:void(0)';
						with: 'run'.
					html imageButton
						class: 'logo-run';
						url: 'javascript:void(0)';
						with: 'run'.
					html imageButton
						class: 'logo-save';
						with: 'save'.
					html div class: 'logo-transcript' ] ]! !

!PRVisitor methodsFor: '*Logo' stamp: 'pmm 6/5/2006 21:55'!
visitLogoPage: anObject
	self visitStructure: anObject! !

WAFileLibrary subclass: #LOLogoFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Logo-Seaside'!

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
EvaluatorJs
	^ 'function Evaluator(turtle, transcript)
{
	this.functions = new Namespace(page);
	this.definitions = this.functions.parent;
	this.variables = new Namespace();
	
	this.addPrimitives(this.functions);

	this.scheduler = new Scheduler();
	this.scheduler.addPrimitives(this.functions);
	
	if (turtle !!= null)
	{
		turtle.addPrimitives(this.functions);
	}
	
	if (transcript !!= null)
	{
		this.transcript = transcript;
		transcript.addPrimitives(this.functions);	
	}
	
	this.assignArity(this.functions);
}


// Utility functions, not in CPS style

Evaluator.prototype.cont = function(k)
{this.scheduler.cont(k)}

Evaluator.prototype.addPrimitives = function(obj)
{
	var self = this;

	obj.run = function(k, list)
	{
		var copy = [].concat(list);
		self.setEscape(k);
		self.run(copy, k)
	}
	
	obj.make = function(k, name, val)
	{
		k(self.variables.parent[name] = val)
	}

}

Evaluator.prototype.assignArity = function(obj)
{
	for (var p in obj)
	{
		var fn = obj[p];
		if (fn instanceof Function) fn.logoArity = fn.length - 1;
	}
}

Evaluator.prototype.eval = function(str)
{
	var self = this;
	var list = Reader.read(str);
	this.scheduler.go();
	this.scheduler.run(function()
	{self.run(list, function(v){})});
}

Evaluator.prototype.findFunction = function(name)
{
	var fun = this.functions[name];
	
	if (fun === undefined)
	{
		this.scheduler.stop();
		var msg = "function ''" + name + "'' is undefined"
		if (this.transcript !!= null) this.transcript.print(msg)
		else St.log(msg);
	}
	return fun;
}

Evaluator.prototype.setEscape = function(k)
{
	this.functions[''return''] = function(kk, v)
	{k(v)};
	this.functions[''return''].logoArity = 1;
}

Evaluator.prototype.inherit = function(obj)
{
	var constructor = function ()
	{};
	constructor.prototype = obj;
	return new constructor();
}

Evaluator.prototype.exportFunctions = function(bool)
{
  if (bool) this.definitions = this.functions.parent;
  else this.definitions = this.functions;
}


// Core evaluation functions, CPS style

Evaluator.prototype.run = function(list, k)
{
	var self = this;
	if(list.length > 0)
		this.runOnce(list, function(v){self.run(list, function(){k(v)})});
	else
		this.cont(k);
}

Evaluator.prototype.runOnce = function(list, k)
{
	var next = list.shift();
	if (next instanceof String)
	{
		if (next.slice(0,1) == ''"'')
			k(next.slice(1));
		else if (next.slice(0,1) == ":") 
			k(this.variables[next.slice(1)])
		else if (next == ''to'')
			this.defineFunction(list, k);
		else if (next == ''('')
			this.callParenthesis(list, k);
		else if (next == '')'')
			k(next)
		else 
			this.callFunction(next, list, k);				
	} else k(next);
}

Evaluator.prototype.defineFunction = function(list, k)
{
	var name = list.shift();
	var next = list.shift();
	var args = [];
	while (next.slice(0,1) == '':'')
	{
		args.push(next.slice(1));
		next = list.shift();
	}
	var content = [];
	while (next !!= ''end'')
	{
		content.push(next);
		next = list.shift();
	}
	
	var self = this;
	var fn = function()
	{
				
		this.run(
			arguments[0],
			[].concat(content)
		);
		
	}
	fn.logoArity = args.length;
	fn.logoArguments = args;
	this.definitions[name] = fn;
	this.cont(k);
}

Evaluator.prototype.callParenthesis = function(list, k)
{
	var name = list.shift();
	var fun = this.findFunction(name);
	if (fun == undefined) return;
	
	var self = this;
	var args = [];
	
	var process_arg = function(v, kk)
	{
		if (v == ")")
		{
			self.executeFunction(fun, args, k);
		} else {
			args.push(v);
			self.cont(kk);
		}
	}
	
	var fetchArgs = function()
	{
		self.runOnce(list, function(v)
		{process_arg(v, fetchArgs)})
	}

	fetchArgs();
}

Evaluator.prototype.callFunction = function(name, list, k)
{
	var fun = this.findFunction(name);
	if (fun == undefined) return;

	var self = this;
	var args = [];
	
	var fetchArg = function(n, kk)
	{
		var kkk = function(v)
		{
			args.push(v); 
			fetchArg(n-1, kk)
		}
		
		if (n == 0) kk()
		else self.runOnce(list, kkk)
	}
	
	fetchArg(
		fun.logoArity, 
		function()
		{self.executeFunction(fun, args, k)}
	)
}

Evaluator.prototype.executeFunction = function(fn, args, k)
{
	var self = this;
	var keep = self.variables;

	self.variables = new Namespace(self.variables);
	if (fn.logoArguments !!== undefined)
		for (var i=0; i<fn.logoArguments.length; i++)
		{
			self.variables[fn.logoArguments[i]] = args[i];
		}
			
	var kk = function (v)
	{self.variables = keep; k(v)}
	self.scheduler.apply(self.functions, fn, args, kk);
}



Namespace = function(parent)
{
	var constructor = function ()
	{};
	constructor.prototype = parent;
	var child = new constructor();
	child.parent = parent;
	return child
};

var primitives = new Object();
var page = new Namespace(primitives);

primitives.repeat = function(k, n, list)
{
	if(n == 0) k()
	else {
		var self = this;
		this.run(function(v){self.repeat(k, n-1, list)}, list);
	}
}
	
primitives[''if''] = function(k, bool, list)
{
	if (bool) this.run(k, list)
	else k()
}

primitives.ifelse = function(k, bool, yes, no)
{
	if (bool) this.run(k, yes)
	else this.run(k, no)
}

// numeric operations
primitives[''+''] = function(k, a, b) {k(a + b)}
primitives[''-''] = function(k, a, b) {k(a - b)}
primitives[''*''] = function(k, a, b) {k(a * b)}
primitives[''/''] = function(k, a, b) {k(a / b)}
primitives[''=''] = function(k, a, b) {k( equals(a,b) )}
primitives[''<''] = function(k, a, b) {k(a < b)}
primitives[''>''] = function(k, a, b) {k(a > b)}

// list operations
primitives.fput = function(k, thing, list) {k([thing].concat(list))}
primitives.lput = function(k, thing, list) {k(list.concat([thing]))}
primitives.first = function(k, list) {k(list[0])}
primitives.butfirst = function(k, list) {k(list.slice(1))}
primitives.last = function(k, list) {k(list[list.length - 1])}
primitives.butlast = function(k, list) {k(list.slice(0,-1))}
primitives.item = function(k, i, list) {k(list[i - 1])}
primitives.empty = function(k, list) {k(list.length == 0)}
primitives.member = function(k, v, list)
{
	var result = false;
	for (var i =0; i < list.length; i++)
	{
		if ( equals(v, list[i]) ) result = true;
	}
	k(result)
}

primitives.list = function (k, first, second)
{
	var list = [];
	for (var i=1; i<arguments.length; i++) list.push(arguments[i]);
	k(list);
}


// word operations
primitives.word = function (k, first, second)
{
	var word = arguments[1];
	for (var i=2; i<arguments.length; i++) word = word + arguments[i];
	k(word);
}


primitives.sentence = function(k, first, second)
{
	var sentence = [];
	var arg;
	for (var i=1; i<arguments.length; i++)
	{
		arg = arguments[i];
		if (typeof arg == ''array'') sentence.concat(arg)
		else sentence.push(arg.toString());
	}
	k(sentence)
}

// convenience
primitives.left = function(k, n) {this.right(k, 360 - n)}
primitives.lt = primitives.left;

function equals(a, b)
{
	return a.valueOf() == b.valueOf();
} 

'! !

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
LogoJs
	^ 'function UIBuilder(node, logo)
{
  this.node = node;
  this.logo = logo;
}

UIBuilder.transform = function(node) {
 var logo = new Logo();
 var builder = new UIBuilder(node, logo);
 return builder.build();
}

UIBuilder.prototype.build = function()
{
  this.findElements();
  this.activateScreen();
  this.activateSprite();
  this.activateTranscript();
  this.activateRun();
  this.activateReset();
  this.activateScopeToggle();
  this.activateCode();
  this.show();
  this.logo.initialize();
  return this.logo;
};

UIBuilder.prototype.findElements = function()
{
  var list = this.node.getElementsByTagName(''*'');
  var element;
  for (var i=0; i<list.length; i++)
  {
    element = list.item(i);
    if (/logo-screen/.test(element.className))
      this.screen = element; 
    if (/logo-transcript/.test(element.className)) 
      this.transcript = element;
    if (/logo-sprite/.test(element.className))
      this.sprite = element; 
    if (/logo-run/.test(element.className)) 
      this.run = element; 
    if (/logo-save/.test(element.className)) 
      this.save = element; 
    if (/logo-reset/.test(element.className)) 
      this.reset = element; 
    if (/logo-code/.test(element.className)) 
      this.code = element;
    if (/logo-toggle/.test(element.className)) 
      this.toggle = element; 
  }
};

UIBuilder.prototype.activateTranscript = function()
{
  if (this.transcript) 
  {
    var contents = this.transcript.firstChild;
    var lines = contents.data.length;
    this.transcript.removeChild(contents);
    this.logo.setTranscriptNode(this.transcript, lines);
  }
  
  // need an else clause here to put in a debugging transcript
  // if no user-visible transcript is specified
};

UIBuilder.prototype.activateRun = function()
{
  var logo = this.logo;
  this.run.onclick = function() 
  {
    try {logo.run()}
    catch (error) {
      log(''error'', error);
    }
    return false;   
  };
};

UIBuilder.prototype.activateReset = function()
{
  if (this.reset) 
  {
    var logo = this.logo;
    this.reset.onclick = function()
    { 
      logo.reset();
      return false;
    }
  }
};

UIBuilder.prototype.activateScopeToggle = function()
{
  if (this.toggle)
  {
    var logo = this.logo;
    this.toggle.onchange = function()
    {
      logo.exportFunctions(this.checked)
      return false;
    }
  }
};

UIBuilder.prototype.activateCode = function()
{
  if (this.code.tagName == ''TEXTAREA'')
  {
    this.code.adjustRows = function() {
  		this.rows = this.value.split("\n").length;
  	}
  	this.code.onchange = this.code.adjustRows;
  	this.code.onkeyup = this.code.adjustRows;
    this.code.adjustRows();
  }
  else
  {
    this.code.value = this.code.firstChild.data;
  }
  
  this.code.run = this.run.onclick;
  this.logo.setCodeNode(this.code);  
};


UIBuilder.prototype.activateScreen = function()
{
	this.logo.setScreenNode(this.screen);
};

UIBuilder.prototype.activateSprite = function()
{
  this.logo.setSpriteNode(this.sprite);
};


UIBuilder.prototype.show = function()
{
  var list = this.node.getElementsByTagName(''div'');
  var element;
  for (var i=0; i<list.length; i++)
  {
    element = list.item(i);
    if (element.className == ''logo-hidden'') 
      element.style.display = ''block'';
  }
};


function Logo() 
{
  this.original = '''';
}

Logo.initialize = function()
{
  this.instances = new Array;
  var elements = document.getElementsByTagName(''*'');
  var node;
  for (var i=0; i<elements.length; i++)
  {
    node = elements.item(i);
    if (node.className == ''logo-root'')
      this.instances.push(UIBuilder.transform(node));
  }
}

Logo.prototype.setCodeNode = function(node)
{
  this.text = node;
  this.original = node.value;
};

Logo.prototype.setScreenNode = function(node)
{
  this.turtle = new Turtle(new Painter(node));
};

Logo.prototype.setSpriteNode = function(node)
{
  this.sprite = new Sprite(node);
};


Logo.prototype.setTranscriptNode = function(node, lines)
{
  this.transcript = new Transcript(node);
  if (lines) this.transcript.limit = lines;
};


Logo.prototype.initialize = function()
{
  this.evaluator = new Evaluator(this.turtle, this.transcript);
  if (this.sprite) this.turtle.setSprite(this.sprite);
};

Logo.prototype.code = function()
{
  return this.text ? this.text.value : this.original;
};

Logo.prototype.run = function()
{
 this.evaluator.eval(this.code());
};

Logo.prototype.reset = function()
{
  this.text.value = this.original;
  this.text.adjustRows();
  this.turtle.clearscreen();
  if (this.transcript) this.transcript.clear();
};

Logo.prototype.exportFunctions = function(bool)
{
  this.evaluator.exportFunctions(bool);
};

'! !

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
PainterJs
	^ 'function Painter(canvas)
{
	this.canvas = canvas;
	this.ctx = this.canvas.getContext("2d");	
	this.ctx.translate(this.width()/2, this.height()/2);
}

Painter.prototype.clearscreen = function()
{
	this.ctx.clearRect(
		-this.width()/2, 
		-this.height()/2, 
		this.width(),
		this.height()
	);
}

Painter.prototype.color = function(color)
{
	this.ctx.strokeStyle = color;
}

Painter.prototype.line = function(ox, oy, dx, dy)
{
		this.ctx.beginPath();
		this.ctx.moveTo(ox, -oy);
		this.ctx.lineTo(dx, -dy);
		this.ctx.stroke();
}

Painter.prototype.width = function()
{
  return this.canvas.getAttribute(''width'');
};

Painter.prototype.height = function()
{
  return this.canvas.getAttribute(''height'');
};

Painter.prototype.initSprite = function(sprite)
{
  sprite.setScreen(this.canvas)
};
'! !

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
ReaderJs
	^ 'function Reader(str) {
	this.str = str;
}

Reader.read = function(str) {
	reader = new Reader(str);
	return reader.read();
}

Reader.prototype.read = function() {
	var list;
	this.str = this.str.replace(/\s*(\[|\]|\(|\)|\+|\-|\*|\/|\=|\<|\>)\s*/g, '' $1 '');
	list = this.transpose(this.str.split(/\s+/));
	return this.readOnce(list);
}

Reader.prototype.transpose = function(list) {
	var result = new Array(list.length);
	for (i=0; i<list.length; i++) {
		each = list[i];
		if (each.length == 0) continue;
		else if (/\+|\*|\/|\-|\=|\<|\>/.test(each)) {
			result[i] = result[i-1];
			result[i-1] = each;
		} else {result[i] = each};
	}
	return result;
}

Reader.prototype.readOnce = function(list) {
   var result = [];
	while(list.length > 0)
	{
		var next = list.shift();
		if(next !!== undefined && next.length > 0)
		{
			if(next == "[")
				result[result.length] = this.readOnce(list);
			else if(next == "]")
				return result;
			else if(new Number(next).toString() !!= "NaN")
				result[result.length] = new Number(next);
			else
				result[result.length] = new String(next);
		}
	}
	return result;
}
'! !

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
SchedulerJs
	^ 'function Scheduler() {
	this.running = true;
	Scheduler.instances.push(this);
}
Scheduler.prototype.speed = 2;
Scheduler.instances = [];

Scheduler.prototype.go = function() {
	this.running = true
}

Scheduler.prototype.stop = function() {
	this.running = false;
}

Scheduler.prototype.run = function(main) {
	this.k = undefined;
	main();
	while (this.running && this.k !!== undefined) {
		var k = this.k;
		this.k = undefined;
		k();
	}
}

Scheduler.prototype.cont = function(k) {
	this.k = k;
}

Scheduler.prototype.apply = function(obj, fn, args, k) {
	var all = [k].concat(args);
	this.k = function() {fn.apply(obj, all)}
}

Scheduler.prototype.delay = function(n, k) {
	var self = this;
	if (this.speed < 1)
  {
    this.cont(k);
  }
  else if (this.running) 
  {
    var kk = function() {self.run(k)}
		window.setTimeout(kk, Math.abs(n/this.speed));	
  }
}

Scheduler.prototype.addPrimitives = function(obj) {
	var self = this;
	obj.delay = function(k, n) {
		self.delay(n, k);
	}	
}

Scheduler.stop = function() {
	for (var p in this.instances) this.instances[p].stop();
}'! !

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
SpriteJs
	^ 'function Sprite(node)
{
  this.sprite = document.createElement(''canvas'');
  this.sprite.style.position = ''absolute'';
  //this.sprite.style.border = ''thin solid #000000'';

  if (node && node.tagName == ''IMG'')
  {
    this.image = node;
    this.draw = function() {this.drawImage()};
    var h = Math.ceil(Math.sqrt(node.width * node.width + node.height * node.height));
    this.sprite.setAttribute(''width'', h);
    this.sprite.setAttribute(''height'', h);
  }
  else if (node) 
  {
    this.code = node;
    this.code.value = this.code.firstChild.data;
    this.turtle = new Turtle(new Painter(this.sprite));
    this.evaluator = new Evaluator(this.turtle);
    this.evaluator.scheduler.speed = 0;
    this.draw = function() {this.drawLogo()}
    this.sprite.setAttribute(''width'', 32);
    this.sprite.setAttribute(''height'', 32);
  }
  else 
  {
    this.draw = function() {this.drawArrow()};
    this.sprite.setAttribute(''width'', 32);
    this.sprite.setAttribute(''height'', 32);
  }

 
}

Sprite.prototype.setScreen = function(screen)
{
  this.screen = screen;
  this.screen.parentNode.insertBefore(this.sprite, this.screen);

  this.ctx = this.sprite.getContext(''2d'');
  this.ctx.translate(this.width()/2, this.height()/2);
  this.ctx.save();
  
  this.home();
};

Sprite.prototype.width = function()
{
  return this.sprite.getAttribute(''width'');
};

Sprite.prototype.height = function()
{
  return this.sprite.getAttribute(''height'');
};

Sprite.prototype.home = function()
{
  this.goTo(0,0);
  this.rotateTo(0);
};

Sprite.prototype.clear = function()
{
  var w = this.sprite.getAttribute(''width'');
  var h = this.sprite.getAttribute(''height'');
  var x = w / 2 * -1;
  var y = h / 2 * -1;
  this.ctx.clearRect(x, y, w, h);
};


Sprite.prototype.goTo = function(x, y)
{
  var cw = this.screen.getAttribute(''width'');
  var ch = this.screen.getAttribute(''height'');
  var sw = this.width()
  var sh = this.height();

  var ax = this.screen.offsetLeft + (cw - sw)/2 ;
  var ay = this.screen.offsetTop + (ch - sh)/2;

  this.sprite.style.left = (ax + x) + ''px'';
  this.sprite.style.top = (ay - y) + ''px'';
};

Sprite.prototype.rotateTo = function(heading)
{
  var radians = heading * Math.PI / 180;
  this.ctx.restore();
  this.clear();
  this.ctx.save();
  this.ctx.rotate(radians);
  this.draw();
};

Sprite.prototype.drawArrow = function()
{
  var style = this.ctx.fillStyle;
  this.ctx.fillStyle = ''rgba(100, 100, 192, 0.4)'';
  this.ctx.beginPath();
  this.ctx.moveTo(0, -8);
  this.ctx.lineTo(8, 8);
  this.ctx.quadraticCurveTo(0,-1,-8,8);
  this.ctx.closePath();
  this.ctx.fill();
  this.ctx.fillStyle = style;
};

Sprite.prototype.drawImage = function()
{
  var x = 0 - this.image.width / 2;
  var y = 0 - this.image.height / 2;
  this.ctx.drawImage(this.image, x, y);
};

Sprite.prototype.drawLogo = function()
{
  this.turtle.clearscreen();
  this.evaluator.eval(this.code.value)
};

'! !

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
TranscriptJs
	^ 'Array.prototype.toString = function()
{
     var str = "";
     for(var i =0; i < this.length; i++)
       str = str + " " + this[i];
     return str;
}

function Transcript(div) {
  if (typeof div == ''string'')
	  this.element = document.getElementById(div);
	else 
	  this.element = div;
	this.contents = [];
	this.limit = 5;
}

Transcript.prototype.addPrimitives = function(obj) {
	var self = this;

	obj.print = function(k, word) {
		self.print(word);
		k()
	}
    
    var oldCs = obj.clearscreen;	
	obj.clearscreen = function() {self.clear();}
}

Transcript.prototype.clear = function() { 
	this.contents = [];
	this.update();
}

Transcript.prototype.print = function(line) {
	this.contents.push(line);
	if (this.contents.length > this.limit)
		this.contents.shift();
	this.update();
}

Transcript.prototype.update = function(update) {
	html = '''';
	for (var i=0; i<this.contents.length; i++) {
		html += this.contents[i];
		html += "<br />";
	}
	this.element.innerHTML = html;
}'! !

!LOLogoFileLibrary methodsFor: 'accessing' stamp: 'pmm 6/5/2006 21:37'!
TurtleJs
	^ 'function Turtle(painter)
{
  this.x = 0;
  this.y = 0;
  this.h = 0;
  this.penIsDown = true;
  this.turtleIsVisible = false;
  this.color = ''#000000'';
  this.painter = painter;
}

Turtle.prototype.setSprite = function(sprite)
{
  this.sprite = sprite;
  this.turtleIsVisible = true;
  this.painter.initSprite(this.sprite);
};


Turtle.prototype.clearscreen = function()
{
  this.painter.clearscreen();
  if (this.sprite) this.sprite.home();
  this.x = 0;
  this.y = 0;
  this.h = 0;
}

Turtle.prototype.forward = function(n)
{
  var theta = this.h * Math.PI / 180
  var x = this.x + Math.sin(theta) * n;
  var y = this.y + Math.cos(theta) * n;
  
  if (this.sprite) 
  {
    this.sprite.goTo(x,y);
  }
  
  if (this.penIsDown)
  {
    this.painter.color(this.color)
    this.painter.line(this.x, this.y, x, y);
  }
    
  this.x = x;
  this.y = y;
}

Turtle.prototype.right = function(n)
{
  this.h = (this.h + n) % 360;
  if (this.sprite && this.turtleIsVisible) this.sprite.rotateTo(this.h);
}

Turtle.prototype.penup = function()
{
  this.penIsDown = false;
}

Turtle.prototype.pendown = function()
{
  this.penIsDown = true;
}

Turtle.prototype.hide = function()
{
  this.sprite.clear();
  this.turtleIsVisible = false;
};

Turtle.prototype.show = function()
{
  this.sprite.goTo(this.x, this.y);
  this.sprite.rotateTo(this.h);
  this.turtleIsVisible = true;
};

Turtle.prototype.addPrimitives = function(namespace)
{
  var self = this;
  
  namespace.clearscreen = function(k)
  {
    self.clearscreen();
    k() 
  }

  namespace.forward = function(k, n)
  {
    self.forward(n);
    this.delay(k, n);
  }

  namespace.right = function(k, n)
  {
    self.right(n);
    k()
  }
  
  namespace.penup = function(k)
  {
    self.penup();
    k()
  }
  
  namespace.pendown = function(k)
  {
    self.pendown();
    k()
  }

  namespace.hideturtle = function(k)
  {
    self.hide();
    k();
  }

  namespace.showturtle = function(k)
  {
    self.show();
    k();
  }

  namespace.color = function(k, color)
  {
    self.color = color;
    k();
  }

  namespace.rgba = function(k, r, g, b, a)
  {
    self.color = ''rgba('' + [r,g,b,a].join() + '')'';
    k();
  }
  
  namespace.xpos = function(k)
  {
    k(self.x)
  }

  namespace.ypos = function(k)
  {
    k(self.y)
  }

  namespace.heading = function(k)
  {
    k(self.h)
  }

  // short forms
  namespace.cs = namespace.clearscreen;
  namespace.fd = namespace.forward;
  namespace.rt = namespace.right;
  namespace.pu = namespace.penup;
  namespace.pd = namespace.pendown;
  namespace.ht = namespace.hideturtle;
  namespace.st = namespace.showturtle;
    
}
'! !

WAScriptLibrary subclass: #LOLogoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Logo-Seaside'!

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:17'!
aReader
	^ 'function Reader(str) {
	this.str = str;
}

Reader.read = function(str) {
	reader = new Reader(str);
	return reader.read();
}

Reader.prototype.read = function() {
	var list;
	this.str = this.str.replace(/\s*(\[|\]|\(|\)|\+|\-|\*|\/|\=|\<|\>)\s*/g, '' $1 '');
	list = this.transpose(this.str.split(/\s+/));
	return this.readOnce(list);
}

Reader.prototype.transpose = function(list) {
	var result = new Array(list.length);
	for (i=0; i<list.length; i++) {
		each = list[i];
		if (each.length == 0) continue;
		else if (/\+|\*|\/|\-|\=|\<|\>/.test(each)) {
			result[i] = result[i-1];
			result[i-1] = each;
		} else {result[i] = each};
	}
	return result;
}

Reader.prototype.readOnce = function(list) {
   var result = [];
	while(list.length > 0)
	{
		var next = list.shift();
		if(next !!== undefined && next.length > 0)
		{
			if(next == "[")
				result[result.length] = this.readOnce(list);
			else if(next == "]")
				return result;
			else if(new Number(next).toString() !!= "NaN")
				result[result.length] = new Number(next);
			else
				result[result.length] = new String(next);
		}
	}
	return result;
}
'! !

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:17'!
bEvaluator
	^ 'function Evaluator(turtle, transcript)
{
	this.functions = new Namespace(page);
	this.definitions = this.functions.parent;
	this.variables = new Namespace();
	
	this.addPrimitives(this.functions);

	this.scheduler = new Scheduler();
	this.scheduler.addPrimitives(this.functions);
	
	if (turtle !!= null)
	{
		turtle.addPrimitives(this.functions);
	}
	
	if (transcript !!= null)
	{
		this.transcript = transcript;
		transcript.addPrimitives(this.functions);	
	}
	
	this.assignArity(this.functions);
}


// Utility functions, not in CPS style

Evaluator.prototype.cont = function(k)
{this.scheduler.cont(k)}

Evaluator.prototype.addPrimitives = function(obj)
{
	var self = this;

	obj.run = function(k, list)
	{
		var copy = [].concat(list);
		self.setEscape(k);
		self.run(copy, k)
	}
	
	obj.make = function(k, name, val)
	{
		k(self.variables.parent[name] = val)
	}

}

Evaluator.prototype.assignArity = function(obj)
{
	for (var p in obj)
	{
		var fn = obj[p];
		if (fn instanceof Function) fn.logoArity = fn.length - 1;
	}
}

Evaluator.prototype.eval = function(str)
{
	var self = this;
	var list = Reader.read(str);
	this.scheduler.go();
	this.scheduler.run(function()
	{self.run(list, function(v){})});
}

Evaluator.prototype.findFunction = function(name)
{
	var fun = this.functions[name];
	
	if (fun === undefined)
	{
		this.scheduler.stop();
		var msg = "function ''" + name + "'' is undefined"
		if (this.transcript !!= null) this.transcript.print(msg)
		else St.log(msg);
	}
	return fun;
}

Evaluator.prototype.setEscape = function(k)
{
	this.functions[''return''] = function(kk, v)
	{k(v)};
	this.functions[''return''].logoArity = 1;
}

Evaluator.prototype.inherit = function(obj)
{
	var constructor = function ()
	{};
	constructor.prototype = obj;
	return new constructor();
}

Evaluator.prototype.exportFunctions = function(bool)
{
  if (bool) this.definitions = this.functions.parent;
  else this.definitions = this.functions;
}


// Core evaluation functions, CPS style

Evaluator.prototype.run = function(list, k)
{
	var self = this;
	if(list.length > 0)
		this.runOnce(list, function(v){self.run(list, function(){k(v)})});
	else
		this.cont(k);
}

Evaluator.prototype.runOnce = function(list, k)
{
	var next = list.shift();
	if (next instanceof String)
	{
		if (next.slice(0,1) == ''"'')
			k(next.slice(1));
		else if (next.slice(0,1) == ":") 
			k(this.variables[next.slice(1)])
		else if (next == ''to'')
			this.defineFunction(list, k);
		else if (next == ''('')
			this.callParenthesis(list, k);
		else if (next == '')'')
			k(next)
		else 
			this.callFunction(next, list, k);				
	} else k(next);
}

Evaluator.prototype.defineFunction = function(list, k)
{
	var name = list.shift();
	var next = list.shift();
	var args = [];
	while (next.slice(0,1) == '':'')
	{
		args.push(next.slice(1));
		next = list.shift();
	}
	var content = [];
	while (next !!= ''end'')
	{
		content.push(next);
		next = list.shift();
	}
	
	var self = this;
	var fn = function()
	{
				
		this.run(
			arguments[0],
			[].concat(content)
		);
		
	}
	fn.logoArity = args.length;
	fn.logoArguments = args;
	this.definitions[name] = fn;
	this.cont(k);
}

Evaluator.prototype.callParenthesis = function(list, k)
{
	var name = list.shift();
	var fun = this.findFunction(name);
	if (fun == undefined) return;
	
	var self = this;
	var args = [];
	
	var process_arg = function(v, kk)
	{
		if (v == ")")
		{
			self.executeFunction(fun, args, k);
		} else {
			args.push(v);
			self.cont(kk);
		}
	}
	
	var fetchArgs = function()
	{
		self.runOnce(list, function(v)
		{process_arg(v, fetchArgs)})
	}

	fetchArgs();
}

Evaluator.prototype.callFunction = function(name, list, k)
{
	var fun = this.findFunction(name);
	if (fun == undefined) return;

	var self = this;
	var args = [];
	
	var fetchArg = function(n, kk)
	{
		var kkk = function(v)
		{
			args.push(v); 
			fetchArg(n-1, kk)
		}
		
		if (n == 0) kk()
		else self.runOnce(list, kkk)
	}
	
	fetchArg(
		fun.logoArity, 
		function()
		{self.executeFunction(fun, args, k)}
	)
}

Evaluator.prototype.executeFunction = function(fn, args, k)
{
	var self = this;
	var keep = self.variables;

	self.variables = new Namespace(self.variables);
	if (fn.logoArguments !!== undefined)
		for (var i=0; i<fn.logoArguments.length; i++)
		{
			self.variables[fn.logoArguments[i]] = args[i];
		}
			
	var kk = function (v)
	{self.variables = keep; k(v)}
	self.scheduler.apply(self.functions, fn, args, kk);
}



Namespace = function(parent)
{
	var constructor = function ()
	{};
	constructor.prototype = parent;
	var child = new constructor();
	child.parent = parent;
	return child
};

var primitives = new Object();
var page = new Namespace(primitives);

primitives.repeat = function(k, n, list)
{
	if(n == 0) k()
	else {
		var self = this;
		this.run(function(v){self.repeat(k, n-1, list)}, list);
	}
}
	
primitives[''if''] = function(k, bool, list)
{
	if (bool) this.run(k, list)
	else k()
}

primitives.ifelse = function(k, bool, yes, no)
{
	if (bool) this.run(k, yes)
	else this.run(k, no)
}

// numeric operations
primitives[''+''] = function(k, a, b) {k(a + b)}
primitives[''-''] = function(k, a, b) {k(a - b)}
primitives[''*''] = function(k, a, b) {k(a * b)}
primitives[''/''] = function(k, a, b) {k(a / b)}
primitives[''=''] = function(k, a, b) {k( equals(a,b) )}
primitives[''<''] = function(k, a, b) {k(a < b)}
primitives[''>''] = function(k, a, b) {k(a > b)}

// list operations
primitives.fput = function(k, thing, list) {k([thing].concat(list))}
primitives.lput = function(k, thing, list) {k(list.concat([thing]))}
primitives.first = function(k, list) {k(list[0])}
primitives.butfirst = function(k, list) {k(list.slice(1))}
primitives.last = function(k, list) {k(list[list.length - 1])}
primitives.butlast = function(k, list) {k(list.slice(0,-1))}
primitives.item = function(k, i, list) {k(list[i - 1])}
primitives.empty = function(k, list) {k(list.length == 0)}
primitives.member = function(k, v, list)
{
	var result = false;
	for (var i =0; i < list.length; i++)
	{
		if ( equals(v, list[i]) ) result = true;
	}
	k(result)
}

primitives.list = function (k, first, second)
{
	var list = [];
	for (var i=1; i<arguments.length; i++) list.push(arguments[i]);
	k(list);
}


// word operations
primitives.word = function (k, first, second)
{
	var word = arguments[1];
	for (var i=2; i<arguments.length; i++) word = word + arguments[i];
	k(word);
}


primitives.sentence = function(k, first, second)
{
	var sentence = [];
	var arg;
	for (var i=1; i<arguments.length; i++)
	{
		arg = arguments[i];
		if (typeof arg == ''array'') sentence.concat(arg)
		else sentence.push(arg.toString());
	}
	k(sentence)
}

// convenience
primitives.left = function(k, n) {this.right(k, 360 - n)}
primitives.lt = primitives.left;

function equals(a, b)
{
	return a.valueOf() == b.valueOf();
} 

'! !

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:18'!
cScheduler
	^ 'function Scheduler() {
	this.running = true;
	Scheduler.instances.push(this);
}
Scheduler.prototype.speed = 2;
Scheduler.instances = [];

Scheduler.prototype.go = function() {
	this.running = true
}

Scheduler.prototype.stop = function() {
	this.running = false;
}

Scheduler.prototype.run = function(main) {
	this.k = undefined;
	main();
	while (this.running && this.k !!== undefined) {
		var k = this.k;
		this.k = undefined;
		k();
	}
}

Scheduler.prototype.cont = function(k) {
	this.k = k;
}

Scheduler.prototype.apply = function(obj, fn, args, k) {
	var all = [k].concat(args);
	this.k = function() {fn.apply(obj, all)}
}

Scheduler.prototype.delay = function(n, k) {
	var self = this;
	if (this.speed < 1)
  {
    this.cont(k);
  }
  else if (this.running) 
  {
    var kk = function() {self.run(k)}
		window.setTimeout(kk, Math.abs(n/this.speed));	
  }
}

Scheduler.prototype.addPrimitives = function(obj) {
	var self = this;
	obj.delay = function(k, n) {
		self.delay(n, k);
	}	
}

Scheduler.stop = function() {
	for (var p in this.instances) this.instances[p].stop();
}'! !

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:18'!
dTurtle
	^ 'function Turtle(painter)
{
  this.x = 0;
  this.y = 0;
  this.h = 0;
  this.penIsDown = true;
  this.turtleIsVisible = false;
  this.color = ''#000000'';
  this.painter = painter;
}

Turtle.prototype.setSprite = function(sprite)
{
  this.sprite = sprite;
  this.turtleIsVisible = true;
  this.painter.initSprite(this.sprite);
};


Turtle.prototype.clearscreen = function()
{
  this.painter.clearscreen();
  if (this.sprite) this.sprite.home();
  this.x = 0;
  this.y = 0;
  this.h = 0;
}

Turtle.prototype.forward = function(n)
{
  var theta = this.h * Math.PI / 180
  var x = this.x + Math.sin(theta) * n;
  var y = this.y + Math.cos(theta) * n;
  
  if (this.sprite) 
  {
    this.sprite.goTo(x,y);
  }
  
  if (this.penIsDown)
  {
    this.painter.color(this.color)
    this.painter.line(this.x, this.y, x, y);
  }
    
  this.x = x;
  this.y = y;
}

Turtle.prototype.right = function(n)
{
  this.h = (this.h + n) % 360;
  if (this.sprite && this.turtleIsVisible) this.sprite.rotateTo(this.h);
}

Turtle.prototype.penup = function()
{
  this.penIsDown = false;
}

Turtle.prototype.pendown = function()
{
  this.penIsDown = true;
}

Turtle.prototype.hide = function()
{
  this.sprite.clear();
  this.turtleIsVisible = false;
};

Turtle.prototype.show = function()
{
  this.sprite.goTo(this.x, this.y);
  this.sprite.rotateTo(this.h);
  this.turtleIsVisible = true;
};

Turtle.prototype.addPrimitives = function(namespace)
{
  var self = this;
  
  namespace.clearscreen = function(k)
  {
    self.clearscreen();
    k() 
  }

  namespace.forward = function(k, n)
  {
    self.forward(n);
    this.delay(k, n);
  }

  namespace.right = function(k, n)
  {
    self.right(n);
    k()
  }
  
  namespace.penup = function(k)
  {
    self.penup();
    k()
  }
  
  namespace.pendown = function(k)
  {
    self.pendown();
    k()
  }

  namespace.hideturtle = function(k)
  {
    self.hide();
    k();
  }

  namespace.showturtle = function(k)
  {
    self.show();
    k();
  }

  namespace.color = function(k, color)
  {
    self.color = color;
    k();
  }

  namespace.rgba = function(k, r, g, b, a)
  {
    self.color = ''rgba('' + [r,g,b,a].join() + '')'';
    k();
  }
  
  namespace.xpos = function(k)
  {
    k(self.x)
  }

  namespace.ypos = function(k)
  {
    k(self.y)
  }

  namespace.heading = function(k)
  {
    k(self.h)
  }

  // short forms
  namespace.cs = namespace.clearscreen;
  namespace.fd = namespace.forward;
  namespace.rt = namespace.right;
  namespace.pu = namespace.penup;
  namespace.pd = namespace.pendown;
  namespace.ht = namespace.hideturtle;
  namespace.st = namespace.showturtle;
    
}
'! !

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:18'!
ePainter
	^ 'function Painter(canvas)
{
	this.canvas = canvas;
	this.ctx = this.canvas.getContext("2d");	
	this.ctx.translate(this.width()/2, this.height()/2);
}

Painter.prototype.clearscreen = function()
{
	this.ctx.clearRect(
		-this.width()/2, 
		-this.height()/2, 
		this.width(),
		this.height()
	);
}

Painter.prototype.color = function(color)
{
	this.ctx.strokeStyle = color;
}

Painter.prototype.line = function(ox, oy, dx, dy)
{
		this.ctx.beginPath();
		this.ctx.moveTo(ox, -oy);
		this.ctx.lineTo(dx, -dy);
		this.ctx.stroke();
}

Painter.prototype.width = function()
{
  return this.canvas.getAttribute(''width'');
};

Painter.prototype.height = function()
{
  return this.canvas.getAttribute(''height'');
};

Painter.prototype.initSprite = function(sprite)
{
  sprite.setScreen(this.canvas)
};
'! !

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:18'!
fSprite
	^ 'function Sprite(node)
{
  this.sprite = document.createElement(''canvas'');
  this.sprite.style.position = ''absolute'';
  //this.sprite.style.border = ''thin solid #000000'';

  if (node && node.tagName == ''IMG'')
  {
    this.image = node;
    this.draw = function() {this.drawImage()};
    var h = Math.ceil(Math.sqrt(node.width * node.width + node.height * node.height));
    this.sprite.setAttribute(''width'', h);
    this.sprite.setAttribute(''height'', h);
  }
  else if (node) 
  {
    this.code = node;
    this.code.value = this.code.firstChild.data;
    this.turtle = new Turtle(new Painter(this.sprite));
    this.evaluator = new Evaluator(this.turtle);
    this.evaluator.scheduler.speed = 0;
    this.draw = function() {this.drawLogo()}
    this.sprite.setAttribute(''width'', 32);
    this.sprite.setAttribute(''height'', 32);
  }
  else 
  {
    this.draw = function() {this.drawArrow()};
    this.sprite.setAttribute(''width'', 32);
    this.sprite.setAttribute(''height'', 32);
  }

 
}

Sprite.prototype.setScreen = function(screen)
{
  this.screen = screen;
  this.screen.parentNode.insertBefore(this.sprite, this.screen);

  this.ctx = this.sprite.getContext(''2d'');
  this.ctx.translate(this.width()/2, this.height()/2);
  this.ctx.save();
  
  this.home();
};

Sprite.prototype.width = function()
{
  return this.sprite.getAttribute(''width'');
};

Sprite.prototype.height = function()
{
  return this.sprite.getAttribute(''height'');
};

Sprite.prototype.home = function()
{
  this.goTo(0,0);
  this.rotateTo(0);
};

Sprite.prototype.clear = function()
{
  var w = this.sprite.getAttribute(''width'');
  var h = this.sprite.getAttribute(''height'');
  var x = w / 2 * -1;
  var y = h / 2 * -1;
  this.ctx.clearRect(x, y, w, h);
};


Sprite.prototype.goTo = function(x, y)
{
  var cw = this.screen.getAttribute(''width'');
  var ch = this.screen.getAttribute(''height'');
  var sw = this.width()
  var sh = this.height();

  var ax = this.screen.offsetLeft + (cw - sw)/2 ;
  var ay = this.screen.offsetTop + (ch - sh)/2;

  this.sprite.style.left = (ax + x) + ''px'';
  this.sprite.style.top = (ay - y) + ''px'';
};

Sprite.prototype.rotateTo = function(heading)
{
  var radians = heading * Math.PI / 180;
  this.ctx.restore();
  this.clear();
  this.ctx.save();
  this.ctx.rotate(radians);
  this.draw();
};

Sprite.prototype.drawArrow = function()
{
  var style = this.ctx.fillStyle;
  this.ctx.fillStyle = ''rgba(100, 100, 192, 0.4)'';
  this.ctx.beginPath();
  this.ctx.moveTo(0, -8);
  this.ctx.lineTo(8, 8);
  this.ctx.quadraticCurveTo(0,-1,-8,8);
  this.ctx.closePath();
  this.ctx.fill();
  this.ctx.fillStyle = style;
};

Sprite.prototype.drawImage = function()
{
  var x = 0 - this.image.width / 2;
  var y = 0 - this.image.height / 2;
  this.ctx.drawImage(this.image, x, y);
};

Sprite.prototype.drawLogo = function()
{
  this.turtle.clearscreen();
  this.evaluator.eval(this.code.value)
};

'! !

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:19'!
gTranscript
	^ 'Array.prototype.toString = function()
{
     var str = "";
     for(var i =0; i < this.length; i++)
       str = str + " " + this[i];
     return str;
}

function Transcript(div) {
  if (typeof div == ''string'')
	  this.element = document.getElementById(div);
	else 
	  this.element = div;
	this.contents = [];
	this.limit = 5;
}

Transcript.prototype.addPrimitives = function(obj) {
	var self = this;

	obj.print = function(k, word) {
		self.print(word);
		k()
	}
    
    var oldCs = obj.clearscreen;	
	obj.clearscreen = function() {self.clear();}
}

Transcript.prototype.clear = function() { 
	this.contents = [];
	this.update();
}

Transcript.prototype.print = function(line) {
	this.contents.push(line);
	if (this.contents.length > this.limit)
		this.contents.shift();
	this.update();
}

Transcript.prototype.update = function(update) {
	html = '''';
	for (var i=0; i<this.contents.length; i++) {
		html += this.contents[i];
		html += "<br />";
	}
	this.element.innerHTML = html;
}'! !

!LOLogoLibrary methodsFor: 'scripts' stamp: 'pmm 6/5/2006 22:20'!
hLogo
	^ 'function UIBuilder(node, logo)
{
  this.node = node;
  this.logo = logo;
}

UIBuilder.transform = function(node) {
 var logo = new Logo();
 var builder = new UIBuilder(node, logo);
 return builder.build();
}

UIBuilder.prototype.build = function()
{
  this.findElements();
  this.activateScreen();
  this.activateSprite();
  this.activateTranscript();
  this.activateRun();
  this.activateReset();
  this.activateScopeToggle();
  this.activateCode();
  this.show();
  this.logo.initialize();
  return this.logo;
};

UIBuilder.prototype.findElements = function()
{
  var list = this.node.getElementsByTagName(''*'');
  var element;
  for (var i=0; i<list.length; i++)
  {
    element = list.item(i);
    if (/logo-screen/.test(element.className))
      this.screen = element; 
    if (/logo-transcript/.test(element.className)) 
      this.transcript = element;
    if (/logo-sprite/.test(element.className))
      this.sprite = element; 
    if (/logo-run/.test(element.className)) 
      this.run = element; 
    if (/logo-save/.test(element.className)) 
      this.save = element; 
    if (/logo-reset/.test(element.className)) 
      this.reset = element; 
    if (/logo-code/.test(element.className)) 
      this.code = element;
    if (/logo-toggle/.test(element.className)) 
      this.toggle = element; 
  }
};

UIBuilder.prototype.activateTranscript = function()
{
  if (this.transcript) 
  {
    var contents = this.transcript.firstChild;
    var lines = contents.data.length;
    this.transcript.removeChild(contents);
    this.logo.setTranscriptNode(this.transcript, lines);
  }
  
  // need an else clause here to put in a debugging transcript
  // if no user-visible transcript is specified
};

UIBuilder.prototype.activateRun = function()
{
  var logo = this.logo;
  this.run.onclick = function() 
  {
    try {logo.run()}
    catch (error) {
      log(''error'', error);
    }
    return false;   
  };
};

UIBuilder.prototype.activateReset = function()
{
  if (this.reset) 
  {
    var logo = this.logo;
    this.reset.onclick = function()
    { 
      logo.reset();
      return false;
    }
  }
};

UIBuilder.prototype.activateScopeToggle = function()
{
  if (this.toggle)
  {
    var logo = this.logo;
    this.toggle.onchange = function()
    {
      logo.exportFunctions(this.checked)
      return false;
    }
  }
};

UIBuilder.prototype.activateCode = function()
{
  if (this.code.tagName == ''TEXTAREA'')
  {
    this.code.adjustRows = function() {
  		this.rows = this.value.split("\n").length;
  	}
  	this.code.onchange = this.code.adjustRows;
  	this.code.onkeyup = this.code.adjustRows;
    this.code.adjustRows();
  }
  else
  {
    this.code.value = this.code.firstChild.data;
  }
  
  this.code.run = this.run.onclick;
  this.logo.setCodeNode(this.code);  
};


UIBuilder.prototype.activateScreen = function()
{
	this.logo.setScreenNode(this.screen);
};

UIBuilder.prototype.activateSprite = function()
{
  this.logo.setSpriteNode(this.sprite);
};


UIBuilder.prototype.show = function()
{
  var list = this.node.getElementsByTagName(''div'');
  var element;
  for (var i=0; i<list.length; i++)
  {
    element = list.item(i);
    if (element.className == ''logo-hidden'') 
      element.style.display = ''block'';
  }
};


function Logo() 
{
  this.original = '''';
}

Logo.initialize = function()
{
  this.instances = new Array;
  var elements = document.getElementsByTagName(''*'');
  var node;
  for (var i=0; i<elements.length; i++)
  {
    node = elements.item(i);
    if (node.className == ''logo-root'')
      this.instances.push(UIBuilder.transform(node));
  }
}

Logo.prototype.setCodeNode = function(node)
{
  this.text = node;
  this.original = node.value;
};

Logo.prototype.setScreenNode = function(node)
{
  this.turtle = new Turtle(new Painter(node));
};

Logo.prototype.setSpriteNode = function(node)
{
  this.sprite = new Sprite(node);
};


Logo.prototype.setTranscriptNode = function(node, lines)
{
  this.transcript = new Transcript(node);
  if (lines) this.transcript.limit = lines;
};


Logo.prototype.initialize = function()
{
  this.evaluator = new Evaluator(this.turtle, this.transcript);
  if (this.sprite) this.turtle.setSprite(this.sprite);
};

Logo.prototype.code = function()
{
  return this.text ? this.text.value : this.original;
};

Logo.prototype.run = function()
{
 this.evaluator.eval(this.code());
};

Logo.prototype.reset = function()
{
  this.text.value = this.original;
  this.text.adjustRows();
  this.turtle.clearscreen();
  if (this.transcript) this.transcript.clear();
};

Logo.prototype.exportFunctions = function(bool)
{
  this.evaluator.exportFunctions(bool);
};

'! !
